// CABdll.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <windows.h>
//#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <sys/stat.h>
#include "Fci.h"
#include "Fdi.h"
#include "CABdll.h"
//#include "Optimize.h"


// max cab size. set to 1 GB so that only one cab will be made.
#define MEDIA_SIZE			1000000000

#define FOLDER_THRESHOLD	900000

typedef struct
{
    long    total_compressed_size;      /* total compressed size so far */
	long	total_uncompressed_size;	/* total uncompressed size so far */
} client_state;

// Globals:

char	ExtractFol[256];   //dest_dir   folder path to extract to.
char	CABToExtract[256];  //cab_fil   path of CAB file the extract.

char sCABFol[256];  //folder to create CAB.
char sCABName[256];  // name of CAB to create.
char sSingleFile[256]; // name of file if single extraction.
char sPathsIn[8192];  //string of file paths for creating CAB.

int      destlen;
int LRet;
int DoAll;

// function declares:

BOOL	test_fdi(char *cabinet_file);
void      store_cab_name(char *cabname, int iCab);
void      set_cab_parameters(PCCAB cab_parms);
BOOL  	test_fci(int num_files);
void      strip_path(char *filename, char *stripped_name);


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

/* ---------------------- Extract ops ------------------------------- */

int WINAPI ExtractCAB(LPSTR sCABPath, LPSTR sDestFolder)

{
int i;

// clear everything:
 LRet = 0;
 DoAll = 1;
 _strset(ExtractFol, 0);   //dest_dir   folder path to extract to.
 _strset(CABToExtract, 0);
 _strset(sSingleFile, 0);

	 i = strlen(sCABPath);
	   if ((i > 255) || (i < 7))
	   {
           return 1;  // 1 - invalid cab path.
	   }

	    strcpy(CABToExtract, sCABPath);  
    

	 destlen = strlen(sDestFolder);
     if ((destlen > 250) || (destlen < 3))
       {
           return 2;  // 2 - invalid folder path.
	   }
	 
        strcpy(ExtractFol, sDestFolder);
       
     
	  if (test_fdi(CABToExtract) == TRUE)
	     return 0;  // 0 - OK.
   	  else
		 if (LRet = 0)
		  { 
			  LRet = 3;
		  }
	     return LRet;   //failed CAB test?

}

/* extract a single file */
int WINAPI ExtractFile(LPSTR sCABPath, LPSTR sDestFolder, LPSTR sFileName)
{
int i2;

// clear everything:
 LRet = 0;
 DoAll = 0;
 _strset(ExtractFol, 0);   //dest_dir   folder path to extract to.
 _strset(CABToExtract, 0);
 _strset(sSingleFile, 0);

	 i2 = strlen(sCABPath);
	   if ((i2 > 255) || (i2 < 7))
	   {
           return 1;  // 1 - invalid cab path.
	   }

	    strcpy(CABToExtract, sCABPath);  
    

	 destlen = strlen(sDestFolder);
     if ((destlen > 250) || (destlen < 3))
       {
           return 2;  // 2 - invalid folder path.
	   }
	 
        strcpy(ExtractFol, sDestFolder);
       
		/* this is the part that's different from full extraction: */
    
      i2 = strlen(sFileName);
	  if (i2 < 2)
	  {
		  return 8;  // no file name.
      }

      strcpy(sSingleFile, sFileName);

	  if (test_fdi(CABToExtract) == TRUE)
	     return 0;  // 0 - OK.
   	  else
		 if (LRet = 0)
		  { 
			  LRet = 3;
		  }
	     return LRet;   //failed CAB test?

}


/*      --------------------- extract support callbacks ------------- */


 // Memory allocation function
FNALLOC(mem_alloc)
{
	return malloc(cb);
}
 // Memory free function
FNFREE(mem_free)
{
	free(pv);
}
FNOPEN(file_open)
{
	return _open(pszFile, oflag, pmode);
}
FNREAD(file_read)
{
	return _read(hf, pv, cb);
}
FNWRITE(file_write)
{
	return _write(hf, pv, cb);
}
FNCLOSE(file_close)
{
	return _close(hf);
}
FNSEEK(file_seek)
{
	return _lseek(hf, dist, seektype);
}
FNFDINOTIFY(notification_function)
{
	switch (fdint)
	{
		case fdintCABINET_INFO: // general information about the cabinet
			return 0;
		case fdintPARTIAL_FILE: // first file in cabinet is continuation		
			return 0;
		case fdintCOPY_FILE:	// file to be copied
		{
			int		handle;
			int Ret2;
			char	destination[256];
			char    CFilName[256];

			_strset(destination, 0); 
			_strset(CFilName, 0); 


				  // if this is a single file extraction then check file name.
				 // only proceed if there's a match.

				if (DoAll == 0) 
				{
			    	sprintf(CFilName, "%s", pfdin->psz1);
                    Ret2 = _stricmp(CFilName, sSingleFile);
                  
                     if (Ret2 != 0)
					 {
						 return 0;
					 }
				     else
					 {
						sprintf(destination, "%s%s", ExtractFol, pfdin->psz1);

                    	handle = file_open(
				    	destination,
				    	_O_BINARY | _O_CREAT | _O_WRONLY | _O_SEQUENTIAL,
				    	_S_IREAD | _S_IWRITE 
			            	);

				    	return handle;				
					 }
				}
				else
				{
                    sprintf(destination, "%s%s", ExtractFol, pfdin->psz1);

					handle = file_open(
					destination,
					_O_BINARY | _O_CREAT | _O_WRONLY | _O_SEQUENTIAL,
					_S_IREAD | _S_IWRITE 
			        	);

					return handle;			
				}	
			}			

		case fdintCLOSE_FILE_INFO:	// close the file, set relevant info
			{
            HANDLE  handle;
            DWORD   attrs;
            char    destination[256];

 			
            sprintf(
                destination, 
                "%s%s",
				ExtractFol,
                pfdin->psz1
                   );

			file_close(pfdin->hf);

                /* Set date/time. Need Win32 type handle for to set date/time   */
            handle = CreateFile(
                destination,
                GENERIC_READ | GENERIC_WRITE,
                FILE_SHARE_READ,
                NULL,
                OPEN_EXISTING,
                FILE_ATTRIBUTE_NORMAL,
                NULL
            );

            if (handle != INVALID_HANDLE_VALUE)
            {
                FILETIME    datetime;

                if (TRUE == DosDateTimeToFileTime(
                    pfdin->date,
                    pfdin->time,
                    &datetime))
                {
                    FILETIME    local_filetime;

                    if (TRUE == LocalFileTimeToFileTime(
                        &datetime,
                        &local_filetime))
                    {
                        (void) SetFileTime(
                            handle,
                            &local_filetime,
                            NULL,
                            &local_filetime
                        );
                     }
                }

                CloseHandle(handle);
            }

            
             /* Mask out attribute bits other than readonly, hidden, system, and archive, since the other
             * attribute bits are reserved for use by the cabinet format.  */
            attrs = pfdin->attribs;
            attrs &= (_A_RDONLY | _A_HIDDEN | _A_SYSTEM | _A_ARCH);
            (void) SetFileAttributes(
                destination,
                attrs
            );
			return TRUE;
        }
		case fdintNEXT_CABINET:	// file continued to next cabinet			
			return 0;
	}
	return 0;
}

/* Main operation for extraction  */
BOOL test_fdi(char *cabinet_fullpath)
{
	HFDI			hfdi;
	ERF				erf;
	FDICABINETINFO	fdici;
	int				hf;
	char			*p;
	char			cabinet_name[256];
	char			cabinet_path[256];

	hfdi = FDICreate(
		mem_alloc,
		mem_free,
		file_open,
		file_read,
		file_write,
		file_close,
		file_seek,
		cpu80386,
		&erf
	);

	if (hfdi == NULL)
	{		
        LRet = 4;
		return FALSE;
	}

           	/* Is this file really a cabinet?	 */
	hf = file_open(cabinet_fullpath, _O_BINARY | _O_RDONLY | _O_SEQUENTIAL, 0);
	if (hf == -1)
	{
		(void) FDIDestroy(hfdi);
        LRet = 5;
		return FALSE;
	}
	if (FALSE == FDIIsCabinet(hfdi, hf, &fdici))
	{
		/* No, it's not a cabinet! */
		_close(hf);
		(void) FDIDestroy(hfdi);
		LRet = 6;
		return FALSE;
	}
	else
	{
		_close(hf);	
	}

	p = strrchr(cabinet_fullpath, '\\');

	if (p == NULL)
	{
		strcpy(cabinet_name, cabinet_fullpath);
		strcpy(cabinet_path, "");
	}
	else
	{
		strcpy(cabinet_name, p+1);
		strncpy(cabinet_path, cabinet_fullpath, (int) (p-cabinet_fullpath)+1);
		cabinet_path[ (int) (p-cabinet_fullpath)+1 ] = 0;
	}

	if (TRUE != FDICopy(hfdi, cabinet_name, cabinet_path, 0, notification_function, NULL, NULL))
	{
		(void) FDIDestroy(hfdi);
		LRet = 7;
		return FALSE;
	}
	if (FDIDestroy(hfdi) != TRUE)
	{
		return FALSE;
	}
	return TRUE;
}


/* XXXXXXXXXXXX END EXTRACT OPS XXXXXXXXXXXXXXXXXXXXXXXXXXX

    ------------    BEGIN MAKE-CAB OPS  -------------------       */

int WINAPI MakeCAB(LPSTR sCABFileName, LPSTR sDestFolder, int iNumFiles, LPSTR FileList)

{
	int i;

	LRet = 0;
    _strset(sCABFol, 0);  //folder to create CAB.
    _strset(sCABName, 0);  // name of CAB to create.
    _strset(sPathsIn, 0);  

	 i = strlen(sDestFolder);
	   if ((i > 255) || (i < 3))
	   {
           return 1;  // 1 - invalid cab destination path.
	   }
     i = strlen(sCABFileName);
	 if (i < 5)
      {
           return 2;  // 2 - invalid cab name. (Doesn't check for extension validity.)
	   }

     if (iNumFiles < 1)
         {
           return 3;  // 3 - 1 file or less. Why isn't 1 file OK? Don't know. MS code does it that way.
	 }
	
	 strcpy(sCABFol, sDestFolder);
	 strcpy(sCABName, sCABFileName);
     strcpy(sPathsIn, FileList);

	if (test_fci(iNumFiles) == TRUE)
	  return 0;
	else
	 return LRet;
	
}

/*
* =============== Ops from here down ======================== 
/*
 * Memory allocation function
 */

FNFCIALLOC(fci_mem_alloc)
{
	return malloc(cb);
}


/* Memory free function */
FNFCIFREE(fci_mem_free)
{
	free(memory);
}
/*  File i/o functions */
FNFCIOPEN(fci_open)
{
    int result;
    result = _open(pszFile, oflag, pmode);
    if (result == -1)
        *err = errno;
    return result;
}
FNFCIREAD(fci_read)
{
    unsigned int result;
    result = (unsigned int) _read(hf, memory, cb);
    if (result != cb)
        *err = errno;
    return result;
}
FNFCIWRITE(fci_write)
{
    unsigned int result;
    result = (unsigned int) _write(hf, memory, cb);
    if (result != cb)
        *err = errno;
    return result;
}
FNFCICLOSE(fci_close)
{
    int result;
    result = _close(hf);
    if (result != 0)
        *err = errno;
    return result;
}
FNFCISEEK(fci_seek)
{
    long result;
    result = _lseek(hf, dist, seektype);
    if (result == -1)
        *err = errno;
    return result;
}
FNFCIDELETE(fci_delete)
{
    int result;
    result = remove(pszFile);
    if (result != 0)
        *err = errno;
    return result;
}

/* File placed function called when a file has been committed to a cabinet  */
FNFCIFILEPLACED(file_placed)
{
	return 0;
}

/* Function to obtain temporary files */
FNFCIGETTEMPFILE(get_temp_file)
{
    char    *psz;
    psz = _tempnam("","xx");            // Get a name
    if ((psz != NULL) && (strlen(psz) < (unsigned)cbTempName)) {
        strcpy(pszTempName,psz);        // Copy to caller's buffer
        free(psz);                      // Free temporary name buffer
        return TRUE;                    // Success
    }
    // Failed
    if (psz) {
        free(psz);
    }
    return FALSE;
}


/*  Progress function */
FNFCISTATUS(progress)
{
	return 0;
}
FNFCIGETNEXTCABINET(get_next_cabinet)
{
	return TRUE;
}
FNFCIGETOPENINFO(get_open_info)
{
	BY_HANDLE_FILE_INFORMATION	finfo;
	FILETIME					filetime;
	HANDLE						handle;
    DWORD                       attrs;
    int                         hf;

    /* Need a Win32 type handle to get file date/time using the Win32 APIs, even though the handle we
     * will be returning is of the type compatible with  _open  */
	handle = CreateFile(pszName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
    	if (handle == INVALID_HANDLE_VALUE)
		{
	    	return -1;
		}

   	if (GetFileInformationByHandle(handle, &finfo) == FALSE)
	{
		CloseHandle(handle);
		return -1;
	}
   
	FileTimeToLocalFileTime(&finfo.ftLastWriteTime, &filetime);
    FileTimeToDosDateTime(&filetime, pdate, ptime);

    attrs = GetFileAttributes(pszName);

    if (attrs == 0xFFFFFFFF)
    {
        /* failure */
        *pattribs = 0;
    }
    else
    {
        /* Mask out all other bits except these four, since other bits are used by the cabinet format to indicate a
         * special meaning.     */
        *pattribs = (int) (attrs & (_A_RDONLY | _A_SYSTEM | _A_HIDDEN | _A_ARCH));
    }

    CloseHandle(handle); 
   
	/* Return handle using _open   */
	hf = _open( pszName, _O_RDONLY | _O_BINARY );
	if (hf == -1)
		return -1; // abort on error
   
	return hf;
}

void set_cab_parameters(PCCAB cab_parms)
{
	memset(cab_parms, 0, sizeof(CCAB));

	cab_parms->cb = MEDIA_SIZE;
	cab_parms->cbFolderThresh = FOLDER_THRESHOLD;

	/*
	 * Don't reserve space for any extensions
	 */
	cab_parms->cbReserveCFHeader = 0;
	cab_parms->cbReserveCFFolder = 0;
	cab_parms->cbReserveCFData   = 0;

               	/* We use this to create the cabinet name    */
	cab_parms->iCab = 1;

             	/* If you want to use disk names, use this to count disk */
	cab_parms->iDisk = 0;
             	/* Choose your own number  */
	cab_parms->setID = 1;

	/* where to store the created CAB files */
	strcpy(cab_parms->szCabPath, sCABFol);

	/* store name of first CAB file */
	strcpy(cab_parms->szCab, sCABName);
}

      /* Main CAB creation function. */
BOOL test_fci(int num_files)
{
	HFCI			hfci;
	ERF				erf;
	CCAB			cab_parameters;
	int				i;
	int  chrP = '|';
	int  LPt1;
	int LPt2;
	char *sPt;
	char	stripped_name[256];  
    char spath[256];
	char uno[1];
	client_state	cs;
    
    cs.total_compressed_size = 0;
	cs.total_uncompressed_size = 0;
    LPt1 = 0;
	LPt2 = 0;
    _strset(uno, 0);

	set_cab_parameters(&cab_parameters);

	hfci = FCICreate(
		&erf,
		file_placed,
		fci_mem_alloc,
		fci_mem_free,
        fci_open,
        fci_read,
        fci_write,
        fci_close,
        fci_seek,
        fci_delete,
		get_temp_file,
        &cab_parameters,
        &cs
	);

	   
	if (hfci == NULL)
	{
		LRet = (erf.erfOper + 10);
		return FALSE;
	}
	  // for each file in array...
	for (i = 0; i < num_files; i++)
	{		
	    	_strset(stripped_name, 0);
	    	_strset(spath, 0);
         sPt = strchr(sPathsIn + LPt2, chrP);
		    if (sPt == NULL)
			{
			   LRet = 4;
			   return FALSE;
			}

          LPt1 = sPt - sPathsIn;      // offset of "|".
		  strncpy(spath, sPathsIn + LPt2, (LPt1 - LPt2));        // copy from beginning up to "|"
		  strncpy(spath + (LPt1 - LPt2), uno, 1);
	   	  LPt2 = LPt1;       // assign point found to counter.
	      LPt2++;           // skip past "|" for next read.
                                //     MessageBox(NULL, spath, "spath op", MB_OK | MB_ICONINFORMATION);  //temp		
	   	  strip_path(spath, stripped_name);         // strip off path.
  
			if (FALSE == FCIAddFile(
					hfci,
					spath,  /* file to add */
					stripped_name, /* file name in cabinet file */
					FALSE, /* file is not executable */
					get_next_cabinet,
					progress,
					get_open_info,
					tcompTYPE_MSZIP))
				{
				
					(void) FCIDestroy(hfci);
					LRet = (erf.erfOper + 20);
					return FALSE;
				}

		}
			
	/* This will automatically flush the folder first */
	if (FALSE == FCIFlushCabinet(hfci, FALSE, get_next_cabinet, progress))
	{	
        (void) FCIDestroy(hfci);
        LRet = (erf.erfOper + 30);
		return FALSE;
	}
  
	if (FCIDestroy(hfci) != TRUE)
	{
		LRet = (erf.erfOper + 40);
		return FALSE;
	}
	return TRUE;
}

void strip_path(char *filename, char *stripped_name)
{
	char	*p1;
	p1 = strrchr(filename, '\\');
	if (p1 == NULL)
		strcpy(stripped_name, filename);
	else
		strcpy(stripped_name, p1+1);
}



